
/**
 * Copyright © 2011 - 2012  Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef FNG_CDB_H
#define FNG_CDB_H

/* libowfat */
#include "stralloc.h"
#include "byte.h"

/* frisbee-ng */
#include "defs.h"

/* dummy for now, I don't want recover errors and so on for now! */
#define MAX_SENSE 64

typedef struct {

	/* fd of sg device */
	int fd;

	/* scsi command */
	stralloc cmd;
	unsigned int cmdlen;	/* 6, 10 or 12 */

	/* buffer for data */
	stralloc buf;
	unsigned int buflen;

	/* buffer for sense */
	stralloc sense;

	/* direction of the data */
	int flags;
#define D_NONE     0x01
#define D_READ     0x02
#define D_WRITE    0x04
} cdb_t;

extern void cdb_init(cdb_t * cdb, int fd, int cmdlen, int buflen);
extern void cdb_free(cdb_t * cdb);

/**
 * send some cdb command to some storage device (scsi / mmc ...)
 * - this function must be ported to other systems...
 * - the implementation is located in cdb_$OS.c
 */
extern int cdb_sendcmd(cdb_t * cmd);

/* get inquiry information */
extern void cdb_inquiry(int fd, char vendor[9], char model[17], char rev[5]);

/* get serial number */
extern void cdb_serial(int fd, char serial[255]);

#endif				/* FNG_CDB_H */
