
/**
 * Copyright © 2011 - 2012 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#include "havebsdio.h"

#ifdef HAVE_BSDSCSIIO

/* system */
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/scsiio.h>

/* frisbee-ng */
#include "cdb.h"
#include "die.h"

int cdb_sendcmd(cdb_t * cmd)
{
	struct scsireq io;
	int r;

	byte_zero(&io, sizeof(io));
	byte_copy(&io.cmd, cmd->cmdlen, cmd->cmd.s);
	byte_copy(&io.sense, SENSEBUFLEN, cmd->sense.s);

	io.flags = 0;
	if (is_set(cmd->flags, D_READ))
		set(io.flags, SCCMD_READ);
	if (is_set(cmd->flags, D_WRITE))
		set(io.flags, SCCMD_WRITE);

	io.timeout = 1000;	/* one second */
	io.cmdlen = cmd->cmdlen;
	io.databuf = cmd->buf.s;
	io.datalen_used = cmd->buflen;

	r = ioctl(cmd->fd, SCIOCCOMMAND, &io);
	if (r != 0)
		return -1;

	/* XXX: no error checking is done currently! /TR */
	return r;
}

#endif
