
/**
 * Copyright © 2011 - 2012 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#include "havebsdsg.h"

#ifdef HAVE_BSDSG

/* system */
#include <sys/types.h>
#include <sys/cdefs.h>
#include <sys/ioctl.h>
#include <cam/scsi/scsi_sg.h>

/* frisbee-ng */
#include "cdb.h"
#include "die.h"

int cdb_sendcmd(cdb_t * cmd)
{
	struct sg_io_hdr io;
	int r;

	byte_zero(&io, sizeof(io));

	io.interface_id = 'S';
	io.timeout = 1000;	/* one second */
	io.cmdp = (unsigned char *)cmd->cmd.s;
	io.cmd_len = cmd->cmdlen;
	io.dxferp = (unsigned char *)cmd->buf.s;
	io.dxfer_len = cmd->buflen;
	io.sbp = (unsigned char *)cmd->sense.s;
	io.mx_sb_len = MAX_SENSE;

	if (is_set(cmd->flags, D_NONE)) {
		set(io.dxfer_direction, SG_DXFER_NONE);
	} else {
		set(io.dxfer_direction, SG_DXFER_TO_FROM_DEV);
	}

	r = ioctl(cmd->fd, SG_IO, &io);
	if (r != 0)
		return -1;

	/* XXX: no error checking is done currently! /TR */
	if (io.sb_len_wr > 0) {
		return -1;
	}

	return r;
}

#endif
