
/**
 * Copyright © 2011 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

/* frisbee-ng */
#include "cdb.h"
#include "die.h"

void cdb_init(cdb_t * cdb, int fd, int cmdlen, int buflen)
{
	stralloc_init(&cdb->cmd);
	if (!stralloc_ready(&cdb->cmd, cmdlen))
		die_nomem();
	byte_zero(cdb->cmd.s, cmdlen);
	cdb->cmdlen = cmdlen;

	stralloc_init(&cdb->buf);
	if (!stralloc_ready(&cdb->buf, buflen))
		die_nomem();
	byte_zero(cdb->buf.s, buflen);
	cdb->buflen = buflen;

	stralloc_init(&cdb->sense);
	if (!stralloc_ready(&cdb->sense, MAX_SENSE))
		die_nomem();
	byte_zero(cdb->sense.s, MAX_SENSE);

	cdb->fd = fd;

	return;
}
