
/**
 * Copyright © 2011 - 2012 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

/* frisbee-ng */
#include "cdb.h"
#include "die.h"
#include "str.h"

#define INQUIRY_SERIAL 0xff

void cdb_serial(int fd, char serial[255])
{
	cdb_t cdb;
	char *x = serial;
	int len;

	cdb_init(&cdb, fd, 6, INQUIRY_SERIAL);

	/* send inquiry command */
	cdb.cmd.s[0] = 0x12;
	cdb.cmd.s[1] = 0x01;
	cdb.cmd.s[2] = 0x80;
	cdb.cmd.s[4] = INQUIRY_SERIAL;
	cdb.flags = D_READ;

	if (cdb_sendcmd(&cdb) == -1) {
		x[0] = '-';
		x[1] = 0;
		cdb_free(&cdb);

		return;
	}

	len = (int)(cdb.buf.s[3]);
	byte_copy(x, len, cdb.buf.s + 4);
	x[len] = 0;

	cdb_free(&cdb);

	return;
}
