
/**
 * Copyright © 2012 - 2013 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Derived from public domain C code in NACL, see http://nacl.cr.yp.to/
 */

#ifndef crypto_core_H
#define crypto_core_H

int crypto_core_hsalsa20x(unsigned char *out, const unsigned char *in,
			  const unsigned char *k, const unsigned char *c,
			  int rounds);

#define crypto_core_hsalsa20(o,i,k,c)   crypto_core_hsalsa20x(o,i,k,c,20)
#define crypto_core_hsalsa208(o,i,k,c)  crypto_core_hsalsa20x(o,i,k,c,8)
#define crypto_core_hsalsa2010(o,i,k,c) crypto_core_hsalsa20x(o,i,k,c,10)
#define crypto_core_hsalsa2012(o,i,k,c) crypto_core_hsalsa20x(o,i,k,c,12)

int crypto_core_salsa20x(unsigned char *out, const unsigned char *in,
			 const unsigned char *k, const unsigned char *c,
			 int rounds);

#define crypto_core_salsa20(o,i,k,c)   crypto_core_salsa20x(o,i,k,c,20)
#define crypto_core_salsa208(o,i,k,c)  crypto_core_salsa20x(o,i,k,c,8)
#define crypto_core_salsa2010(o,i,k,c) crypto_core_salsa20x(o,i,k,c,10)
#define crypto_core_salsa2012(o,i,k,c) crypto_core_salsa20x(o,i,k,c,12)

#endif
