
/**
 * Copyright © 2013 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef crypto_nonce_H
#define crypto_nonce_H

/**
 * this interface is thread safe
 */

#include "src/defs.h"

/* 8 byte nonce */
extern void crypto_nonce8_reset(void);	/* reset */
extern void crypto_nonce8(unsigned char *nonce);	/* increment it  */
extern void crypto_nonce8_u64(u64 * u);

/* 24 byte nonce */
extern void crypto_nonce24_reset(void);	/* reset */
extern void crypto_nonce24(unsigned char *nonce);	/* increment it  */

#endif
