
/**
 * Copyright © 2012 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Derived from public domain C code in NACL, see http://nacl.cr.yp.to/
 */

#ifndef crypto_scalarmult_curve25519_H
#define crypto_scalarmult_curve25519_H

#define crypto_scalarmult crypto_scalarmult_curve25519
#define crypto_scalarmult_base crypto_scalarmult_curve25519_base

/* This function multiplies a group element p[0], ...,
 * p[crypto_scalarmult_BYTES-1] by an integer n[0], ...,
 * n[crypto_scalarmult_SCALARBYTES-1]. It puts the resulting group element
 * into q[0], ..., q[crypto_scalarmult_BYTES-1] and returns 0.
 */
int crypto_scalarmult_curve25519(unsigned char *q, const unsigned char *n,
				 const unsigned char *p);

/* The crypto_scalarmult_base function computes the scalar product of a
 * standard group element and an integer n[0], ...,
 * n[crypto_scalarmult_SCALARBYTES-1]. It puts the resulting group element
 * into q[0], ..., q[crypto_scalarmult_BYTES-1] and returns 0.
 */
int crypto_scalarmult_curve25519_base(unsigned char *q, const unsigned char *n);

#endif
