
/**
 * Copyright © 2012 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Derived from public domain C code in NACL, see http://nacl.cr.yp.to/
 */

#include "crypto_verify.h"

#define F(i) differentbits |= x[i] ^ y[i];

int crypto_verify_8(const unsigned char *x, const unsigned char *y)
{
	unsigned int differentbits = 0;

	F(0) F(1) F(2) F(3) F(4) F(5) F(6) F(7)
	    return (1 & ((differentbits - 1) >> 8)) - 1;
}

int crypto_verify_16(const unsigned char *x, const unsigned char *y)
{
	unsigned int differentbits = 0;

	F(0) F(1) F(2) F(3) F(4) F(5) F(6) F(7) F(8) F(9) F(10) F(11)
	    F(12) F(13) F(14) F(15) return (1 & ((differentbits - 1) >> 8)) - 1;
}

int crypto_verify_32(const unsigned char *x, const unsigned char *y)
{
	unsigned int differentbits = 0;

	F(0) F(1) F(2) F(3) F(4) F(5) F(6) F(7) F(8) F(9) F(10) F(11)
	    F(12) F(13) F(14) F(15) F(16) F(17) F(18) F(19) F(20) F(21)
	    F(22) F(23) F(24) F(25) F(26) F(27) F(28) F(29) F(30) F(31)
	    return (1 & ((differentbits - 1) >> 8)) - 1;
}
