
/**
 * Copyright © 2005 - 2012 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef DEBUG_H
#define DEBUG_H

/* system */
#include <unistd.h>

#define MAX_SECTION 50		/* 0..49 */

/*
 * #define debug(s,l,fmt,args...)  do { debug_r(s,l,fmt,##args); } while (0)
 */

/* developer may choose the last line :) */
#if 0
#define debug
#else

/* developer */
extern unsigned int debugging[];
extern void debug_r(unsigned int section, unsigned int level, const char *fmt,
		    ...);

#define debug(s,l,fmt,args...)  do { \
	debug_r(s,l,"%24s(@%4u)[%u,%u]: " fmt, \
	__func__, __LINE__, s, l, ##args); \
} while (0)

#endif

#endif
