
/**
 * Copyright © 2008 - 2012 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef FNG_DIE_H
#define FNG_DIE_H

#include <sys/types.h>
#include <stdlib.h>
#include <errno.h>

#include "debug.h"
#include "tty.h"

extern void __die_msg(int r, const char *message, ...);

#define die_msg(r,...) do { __die_msg(r,__VA_ARGS__,(char*)0); } while (0)

/* these should never happen! */
extern void die_io(void);
extern void die_guru(void);
extern void die_perm(void);
extern void die_nomem(void);
extern void die_crypto(void);
extern void _die_pthread(int r);

#define die_pthread(r) do { debug(1,1,"pthread error!"); _die_pthread(r); } while (0)

extern void die_rzip(const char *m);
extern void die_term(const char *m);
extern void die_lseek(size_t pos, const char *at);
extern void die_compr(const char *msg, int ret);
extern void die_pread(const char *fs);

/* show some error and terminate execution! */
#define fatal(fmt,args...)  do { die_msg(111,fmt,##args); } while (0)

#endif
