
/**
 * Copyright © 2012 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * debug section: NONE
 *
 **
 * "foo" -> "foo  "
 */

#include "fmtX.h"

size_t fmt_padleft(char *dest, size_t srclen, size_t padlen, size_t maxlen,
		   char with)
{
	char *olddest = dest;
	char *max = dest + maxlen;
	long todo;

	if (!dest) {
		unsigned long sum = padlen > srclen ? padlen - srclen : srclen;

		return sum > maxlen ? maxlen : sum;
	}

	todo = padlen - srclen;
	for (; todo > 0; --todo) {
		if (dest > max)
			break;
		*dest = with;
		++dest;
	}

	return dest - olddest;
}
