
/**
 * Copyright © 2012 - 2013 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * debug section: NONE
 */

/* frisbee */
#include "defs.h"
#include "fmtX.h"
#include "crypt.h"
#include "randombytes.h"
#include "havecpuid.h"

/* libowfat */
#include "uint32.h"

size_t fmt_urandom(unsigned char *dst, int count)
{
	static unsigned char key[32];
	static int init_done = 0;
	unsigned char nonce[24];

	if (!dst)
		return count;

	if (unlikely(init_done == 0)) {
		randombytes(key, 32);
		init_done = 1;
	}

	crypto_nonce24(nonce);
	crypto_stream_xsalsa208(dst, count, nonce, key);

	return count;
}

size_t fmt_random(char *dst, int count)
{
	unsigned char *dest = (unsigned char *)dst;

	return fmt_urandom(dest, count);
}
