
/**
 * Copyright © 2001 - 2012 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * debug section: NONE
 */

#include "fmtX.h"
#include "defs.h"

size_t fmt_uuid(char *dst, const char i[16])
{
	u64 u1, u2;
	char *x;
	char *minus = "-";

	/**
	 * 58f9fd63-16c9-4d0b-b1c0-2462968b63a3
	 * 8-4-4-4-12 = 32+4
	 */
	if (!dst)
		return 32 + 4;

	u1 = (u64) i[0];
	u2 = (u64) i[8];
	x = dst;

	x += fmt_xlonglong(x, u1 & 0xffff0000);
	x += fmt_str(x, minus);
	x += fmt_xlonglong(x, u1 & 0x0000ff00);
	x += fmt_str(x, minus);
	x += fmt_xlonglong(x, u1 & 0x000000ff);
	x += fmt_str(x, minus);
	x += fmt_xlonglong(x, u2 & 0xff000000);
	x += fmt_str(x, minus);
	x += fmt_xlonglong(x, u2 & 0x00ffffff);

	return x - dst;
}
