
/**
 * Copyright © 2005-2008 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef LOG_H
#define LOG_H

/* system */
#include <unistd.h>

/* libowfat */
#include "stralloc.h"

/* frisbee-ng */
#include "debug.h"

extern void log_init(void);
extern void log_timestamp(void);
extern void log_s(char *s);
extern void log_sa(stralloc * sa);
extern void log_flush(void);
extern void log_sa_flush_nl(stralloc * sa);
extern void log_headline(char *headline);

/* wrapper for write, we use a mutex here! */
extern ssize_t log_write(int fd, const void *buf, size_t count);

#endif
