
/**
 * Copyright © 2008 - 2016 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef FNG_MAIN_H
#define FNG_MAIN_H

/**
 * we have different programs in one binary here
 */
extern int fng_image(int argc, char **argv);
extern int fng_restore(int argc, char **argv);
extern int fng_info(int argc, char **argv);
extern int fng_shredder(int argc, char **argv);
extern int fng_clone(int argc, char **argv);
extern int fng_client(int argc, char **argv);
extern int fng_server(int argc, char **argv);
extern int fng_adhoc(int argc, char **argv);
extern int fng_encode(int argc, char **argv, int mode);

/**
 * can be used for the worker pools
 */
extern int fng_cpucount;

extern int fng_main;		/* FNG_MAIN_* */

extern const char *fng_version;
extern const char *fng_name;

#define FNG_MAIN_IMAGE       1
#define FNG_MAIN_RESTORE     2
#define FNG_MAIN_INFO        3
#define FNG_MAIN_SHREDDER    4
#define FNG_MAIN_CLONE       5
#define FNG_MAIN_CLIENT      6
#define FNG_MAIN_SERVER      7
#define FNG_MAIN_ADHOC       8
#define FNG_MAIN_ENCODE      9
#define FNG_MAIN_DECODE     10

extern char *fng_server_name;

/**
 * version - show version of program and exit
 */
extern void version(void);

/**
 * fng_exit - exit current frisbee process
 */
extern int fng_exit(int status);

#endif
