
/**
 * Copyright © 2012 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef FNG_OPENX_H
#define FNG_OPENX_H

/**
 * some extensions to the standard libowfat open routines
 */

#include "open.h"

/**
 * open_device_ro - open device for reading
 * @filename: path to device
 *
 * returns the file handle or calls die_msg() on failure
 */
int open_device_ro(const char *filename);

/**
 * open_device_ro - open device for reading and writing
 * @filename: path to device
 *
 * returns the file handle or calls die_msg() on failure
 */
int open_device_rw(const char *filename);

/**
 * open_device_trunc - open device for writing
 * @filename: path to device,
 * - the file will be truncated to zero bytes length
 *
 * returns the file handle or calls die_msg() on failure
 */
int open_device_trunc(const char *filename);

#endif
