
/**
 * Copyright © 2012 - 2016 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

/* system */
#include <stdlib.h>

/* libowfat */
#include "io.h"

/* frisbee-ng */
#include "defs.h"
#include "die.h"
#include "openX.h"
#include "wrapper.h"

#define MODE_RO 0
#define MODE_RW 1
#define MODE_TRUNC 2

static int open_device(int mode, const char *filename)
{
	int fd = -1;

	if (mode == MODE_RO)
		fd = open_read(filename);
	else if (mode == MODE_RW)
		fd = open_rw(filename);
	else if (mode == MODE_TRUNC)
		fd = open_trunc(filename);

	if (fd == -1) {
		die_msg(111, "Error opening \"", filename, "\"!");
	}

	io_fd2(fd);

	return fd;
}

int open_device_ro(const char *filename)
{
	return open_device(MODE_RO, filename);
}

int open_device_rw(const char *filename)
{
	return open_device(MODE_RW, filename);
}

int open_device_trunc(const char *filename)
{
	return open_device(MODE_TRUNC, filename);
}
