
/**
 * Copyright © 2014 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifdef __linux__

/* system */
#include <sys/utsname.h>

/* frisbee-ng */
#include "os.h"
#include "mem.h"

char *os_gethostname(void)
{
	static char *hostname = 0;

	if (!hostname) {
		/* we store it forever... */
		struct utsname *u = mem_talloc(struct utsname, 1);

		uname(u);
		hostname = u->nodename;
	}

	return hostname;
}

#endif
