
/**
 * Copyright © 2014 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#include "src/mem.h"
#include "quicklz.h"

#define QLZ_COMPRESSION_LEVEL 2
#define QLZ_STREAMING_BUFFER  0
#include "quicklz_p.h"

int quicklz_compress2(const void *ubuf, int ulen, void *cbuf)
{
	qlz_state_compress *qsc = mem_tzalloc(qlz_state_compress, 1);
	int clen;

	/* must be zero */
	clen = qlz_compress(ubuf, cbuf, ulen, qsc);
	free(qsc);

	return clen;
}

int quicklz_decompress2(void *cbuf, void *ubuf)
{
	qlz_state_decompress *qsd;
	int ulen;

	qsd = mem_tzalloc(qlz_state_decompress, 1);
	ulen = qlz_decompress(cbuf, ubuf, qsd);
	free(qsd);

	return ulen;
}
