
/**
 * Copyright © 2010 - 2014 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#include "wrapper.h"

s64 read_loop(int fd, void *buffer, u64 count)
{
	s64 offset;

	offset = 0;
	while (count > 0) {
		s64 block = read(fd, buffer + offset, count);

		if (block < 0)
			return block;
		if (!block)
			return offset;

		offset += block;
		count -= block;
	}

	return offset;
}

void read_loop2(int fd, void *buffer, u64 count)
{
	if (read_loop(fd, buffer, count) != (s64) count)
		fatal("show read()");
}
