
/**
 * Copyright © 2009 - 2012 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

/* libowfat */
#include "openreadclose.h"
#include "stralloc.h"

/* fribee-ng */
#include "die.h"
#include "read_skipfile.h"

stralloc fng_skipfile;

void read_skipfile(char *file)
{
	int r;
	unsigned i;

	stralloc_init(&fng_skipfile);
	r = openreadclose(file, &fng_skipfile, 1024 * 10);

	if (r != 1)
		die_msg(2, "Can't open ", file, " :-(");

	/* split the stralloc @ each newline, this is used in later parsing */
	for (i = 0; i < fng_skipfile.len; i++)
		if (fng_skipfile.s[i] == '\n')
			fng_skipfile.s[i] = 0;

	return;
}
