
/**
 * Copyright © 2008 - 2013 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef FNG_SOCKET_H
#define FNG_SOCKET_H

/* libowfat */
#include "uint64.h"

/* frisbee-ng */
#include "defs.h"

extern u32 sc_scope_id;

/**
 * create udp socket and bind to it
 */
extern int64 sc_udp(char ip[16], u16 port);

/**
 * create multicast udp socket and bind to it
 */
extern int64 sc_multicast(char ip[16], u16 port, char ttl, char loop);

/**
 * create broadcast udp socket
 */
extern int64 sc_broadcast(void);

/**
 * send datagram
 */
extern ssize_t sc_send(int64 sock, char *buf, size_t len, const char ip[16],
		       u16 port);

/**
 * receive datagram
 */
extern ssize_t sc_recv(int64 s, char *buf, size_t len, char ip[16], u16 * port);

#endif
