
/**
 * Copyright © 2005 - 2012 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

/* system */
#include <unistd.h>
#include <stdlib.h>
#include <signal.h>

/* frisbee-ng */
#include "sig.h"
#include "term.h"
#include "tty.h"
#include "die.h"
#include "main.h"
#include "strallocX.h"

void sig_handler(int sig)
{
	stralloc sa;

	/* screen size has changed */
	if (sig == SIGWINCH) {
		term_resize();
		return;
	}

	if (fng_main == FNG_MAIN_SHREDDER)
		if (sig == SIGINT) {
			/* exit with a small 'killed by sig X' message */
			term_printflush
			    ("\nSIG_INT catched, syncing now via generic sync() call... ");
			sync();
			sync();
			sync();
			term_print
			    ("\nWarning, your disk is not ready for ebay!\n");
		}

	/* exit with a small 'killed by sig X' message */
	term_quit();
	tty_restore();

	stralloc_init(&sa);
	if (!stralloc_copys(&sa, "killed by signal: "))
		die_nomem();
	if (!stralloc_cat_uint(&sa, (unsigned int)sig))
		die_nomem();
	if (!stralloc_cats(&sa, "\n"))
		die_nomem();
	while (buffer_putsaflush(buffer_2, &sa) == -1) ;
	stralloc_free(&sa);

	_exit(sig);
}
