
/**
 * Copyright © 2010 - 2012 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#include "havesplice.h"

#ifdef HAVE_SPLICE

#include "splice.h"
#include "die.h"
#include "wrapper.h"

s64 tee_loop(int fd_in, int fd_out, u64 len, unsigned int flags)
{
	s64 done = 0;

	do {
		s64 tlen = sys_tee(fd_in, fd_out, len, flags);

		if (tlen < 0)
			die_msg(111, "tee()");
		if (tlen == 0)
			return done;

		done += tlen;
	}
	while (done != (s64) len);

	return done;
}

#endif
