
/**
 * Copyright © 2010 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * debug section: 13
 */

/* system */
#include <sys/types.h>
#include <stdarg.h>

/* frisbee-ng */
#include "strallocX.h"
#include "term.h"

/**
 * some simple formatting for our terminal ;)
 */
void term_print(const char *fmt, ...)
{
	stralloc buf;
	va_list ap;

	stralloc_init(&buf);

	va_start(ap, fmt);
	stralloc_fmt(&buf, fmt, ap);
	va_end(ap);

	term_sa(&buf);
	stralloc_free(&buf);

	return;
}

void term_printflush(const char *fmt, ...)
{
	stralloc buf;
	va_list ap;

	stralloc_init(&buf);

	va_start(ap, fmt);
	stralloc_fmt(&buf, fmt, ap);
	va_end(ap);

	term_sa(&buf);
	stralloc_free(&buf);
	term_flush();

	return;
}
