
/**
 * Copyright © 2014 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#include "defs.h"
#include "term.h"
#include "tty.h"
#include "strallocX.h"

/**
 * for showing some progress bar @ terminal
 */
void term_progress(int x_start, int x_end, int percent)
{
	int i, len;

	len = x_end - x_start - 1;

	if (unlikely(len < 5))
		fatal("len to small @ term_progress()");

	//term_printflush("percent: %u", percent);
	if (unlikely(percent < 0))
		fatal("percent @ term_progress()");

	if (unlikely(percent > 100))
		fatal("percent @ term_progress()");

/**
 * prozent   100
 * linelen   30
 *
 *  1% ->  0 balken ->  1 * 30 ->   30 
 *  2% ->  0 balken ->  2 * 30 ->   60
 *  3% ->  0 balken ->  3 * 30 ->   90
 *  4% ->  1 balken ->  4 * 30 ->  120 -> 1x 100 geht rein, also 1 balken
 * 50% -> 15 balken -> 50 * 30 -> 1500 -> 15x 100 geht rein, also 15 balken
 */

	term_s("[");
	for (i = percent * len; i > 0; i -= 100) {
		if (i > 100)
			term_s("=");
		else
			term_s(">");
		len--;
	}

	while (len > 0) {
		term_s(" ");
		len--;
	}
	term_s("]");

	return;
}
