
/**
 * Copyright © 2008 - 2016 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * debug section: 13
 */

#include "main.h"
#include "term.h"
#include "tty.h"

/**
 * called every time, the terminal size changes and so on
 * - init also the main interface
 * - clears the screen before that
 */
void term_resize(void)
{
	term_flush();
	tty_getsize(&term_maxx, &term_maxy);

	switch (fng_main) {
	case FNG_MAIN_CLONE:
		term_fng_clone();
		break;
	case FNG_MAIN_IMAGE:
		term_fng_clone();
		break;
	case FNG_MAIN_ADHOC:
		term_s(term_str_norm);
		term_s(term_str_clear);
		//term_s(term_str_init);
		//term_box(1, 1, term_maxx, term_maxy - 1);
		term_adhoc_server();
		//term_clustermap();
		break;
	}
	term_flush();

	return;
}
