
/**
 * Copyright © 2005-2008 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * debug section: NONE
 */

/* libowfat */
#include "taia.h"

/* squidwall */
#include "timestamp.h"
#include "hextab.h"

void timestamp(char s[FMT_TIMESTAMP])
{
	struct taia now;
	char nowpack[TAIA_PACK];
	int i;

	taia_now(&now);
	taia_pack(nowpack, &now);

	s[0] = '@';
	for (i = 0; i < 12; ++i) {
		s[i * 2 + 1] = hextab[(nowpack[i] >> 4) & 15];
		s[i * 2 + 2] = hextab[nowpack[i] & 15];
	}

	return;
}
