
/**
 * Copyright © 2010 - 2014 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

/* fribee-ng */
#include "defs.h"
#include "mem.h"
#include "wrapper.h"
#include "transport.h"

/* 100 kb bufsize */
#define BUFLEN   100 * 1024
void tp_rdwr_clone(int fd_in, int dst_count, int64 * fds, s64 off, s64 bytes)
{
	u8 *buf = mem_alloc(BUFLEN);
	s64 done = 0;

	do {
		int out;
		s64 todo = min(BUFLEN, bytes - done);

		/* read once */
		pread_loop2(fd_in, buf, todo, off + done);

		/* write to multiple - if wanted */
		for (out = 0; out < dst_count; out++) {
			pwrite_loop2(fds[out], buf, todo, off + done);
		}

		done += todo;
	}
	while (done != bytes);
	mem_free(buf);

	return;
}
