
/**
 * Copyright © 2014 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

/* libowfat */
#include "byte.h"

/* fribee-ng */
#include "defs.h"
#include "mem.h"
#include "wrapper.h"
#include "transport.h"

/* 100 kb bufsize */
#define BUFLEN   100 * 1024

void tp_readtest(int fd_in, int dst_count, int64 * fds, s64 off, s64 bytes)
{
	u8 *buf = mem_alloc(BUFLEN);
	u8 *check = mem_alloc(BUFLEN);
	s64 done = 0;

	do {
		int out;
		s64 todo = min(BUFLEN, bytes - done);

		/* read once */
		pread_loop2(fd_in, buf, todo, off + done);
		for (out = 0; out < dst_count; out++) {
			pread_loop2(fds[out], check, todo, off + done);
			if (byte_diff(buf, todo, check) != 0)
				die_msg(111,
					"readtest failed.. some writes are not good!");
		}

		done += todo;
	}
	while (done != bytes);

	mem_free(buf);
	mem_free(check);

	return;
}
