
/**
 * Copyright © 2010 - 2014 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * debug section: 10
 */

/* system */
#include <sys/types.h>
#include <unistd.h>

/* libowfat */
#include "io.h"

/* frisbee-ng */
#include "defs.h"
#include "wrapper.h"
#include "transport.h"

/* we use the libowfat sendfile wrapper... should work on most systems */
void tp_sendfile_clone(int fd_in, int dst_count, int64 * fds, s64 off,
		       s64 bytes)
{
	int out;

	/* int64 io_sendfile(int64 s,int64 fd,uint64 off,uint64 n) */
	for (out = 0; out < dst_count; out++) {
		s64 offset = off;
		s64 r;

		/* should we add some mutex here? /TR */
		lseek(fds[out], offset, SEEK_SET);
		r = io_sendfile(fds[out], fd_in, offset, bytes);
		if (r != bytes)
			die_msg(111, "sendfile()");
	}

	return;
}
