
/**
 * Copyright © 2009 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#include "utf8.h"

/* very simple and okay, I hope ;) */
static inline int utf8_clen(int src /* 32bit -> 4 byte max */ )
{
	if ((src & 0x80) == 0)
		return 1;

	if ((src & 0xff) >= 0xc2)
		if ((src & 0xff) <= 0xdf)
			return 2;

	if ((src & 0xf0) == 0xe0)
		return 3;
	if ((src & 0xff) == 0xf0)
		return 4;

	return 0;
}

int utf8_len(char *str)
{
	int len = 0;

	if (!str)
		return 0;
	while (*str) {
		int ch = *str;
		int sl = utf8_clen(ch);

		if (sl) {
			len++;
			str += sl;
		} else {
			str++;
		}
	}

	return len;
}
