
/**
 * Copyright © 2010 - 2014 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#include "wrapper.h"

s64 write_loop(int fd, const void *buffer, u64 count)
{
	s64 done = 0;

	while (count > 0) {
		s64 block = write(fd, buffer + done, count);

		if (block < 0)
			return block;
		if (!block)
			return done;

		done += block;
		count -= block;
	}

	return done;
}

void write_loop2(int fd, const void *buffer, u64 count)
{
	if (write_loop(fd, buffer, count) != (s64) count)
		fatal("short write()");
}
